<template>
    <Menubar :model="token ? itemsIfLoged : itemsIfNotLoged">
        <template #start>
            <h2>CHILLGAMES</h2>
        </template>
        <template #item="{item}">
            <p class="nav-content" @click="item.click">{{item.label}}</p>
        </template>
        <template #end>
            
        </template>
    </Menubar>
</template>
<script>
import VueJwtDecode from 'vue-jwt-decode';
import Menubar from 'primevue/menubar';

export default {
    name: "Header",
    data() {
        return {
            refHome: 'btnHome',
            refGames: 'btnGames',
            refProfil: 'btnProfil',
            token: localStorage.getItem('token'),
            userData: localStorage.getItem("token") ? VueJwtDecode.decode(localStorage.getItem("token")) : null,
            optionsRef: 'optionsOpen',
            language: this.userData && this.userData.language ? this.userData.language : 'English',
            itemsIfLoged: [
                {
                    label:'Home',
                    click: this.goHome
                },
                {
                    label:'Games',
                    click: this.goGames
                },
                {
                    label:'Profil',
                    click: this.goProfile
                },
                {
                    label:'Logout',
                    click: this.logout
                }
            ],
            itemsIfNotLoged: [
                {
                    label:'Home',
					icon:'pi pi-fw pi-file',
                    click: this.goHome
                },
                {
                    label:'Games',
					icon:'pi pi-fw pi-file',
                    click: this.goGames
                },
                {
                    label:'Login',
					icon:'pi pi-fw pi-file',
                    click: this.goLogin
                },
                {
                    label:'Register',
					icon:'pi pi-fw pi-file',
                    click: this.goRegister
                }
            ]
        }
    },
    components: {
        Menubar
    },
    methods: {
        goHome(){
            this.$router.push('/');
        },
        goGames(){
            this.$router.push('/games');
        },
        goProfile(){
            this.$router.push('/profile');
        },
        goLogin(){
            this.$router.push('/login');
        },
        goRegister(){
            this.$router.push('/register');
        },
        goParty(party){
            this.$router.push(`/room/${party.name}/${party.id}`);
        },
        openOptions(){
            this.$refs.optionsOpen.classList.toggle('optionsOpen-active');
            document.querySelector('.roll').classList.toggle('roll-active');
        },
        logout(){
            localStorage.removeItem('token');
            this.token = null;
            this.userData = null;
            this.goHome();
        },
        goProfileOptions(){
            this.$refs.optionsOpen.classList.toggle('optionsOpen-active');
            document.querySelector('.roll').classList.toggle('roll-active');
            this.goProfile();
        },
    },
    computed: {
        username(){
            return this.$store.state.username;
        },
        profilePicture(){
            return this.$store.state.profilePicture;
        },
        party(){
            return this.$store.state.party;
        },
    },
    props: ['page'],
    mounted(){
        if(this.party) {
            this.itemsIfLoged.push(
                {
                    label:'Party',
                    click: this.goParty({
                        name: this.party.name,
                        id: this.party.id
                    })
                }
            )
        }
    },
}
</script>

<style scoped>
    .p-menubar {
        width: 100%;
        height: 90px;
        background: none;
        color: #ffffff;
        position: absolute;
        border: none;
        display: flex;
    }

    .p-menubar h2
    {
        font-family: 'Oswald-Bold';
        font-size: 50px;
    }

    .nav-content
    {
        font-family: 'Oswald';
        font-size: 25px;
        text-decoration: none;
        color: #ffffff;
        background: none;
        border: none;
        margin-left: 50px;
        display: flex;
        flex-direction: column;
        cursor: pointer;
        transition: 0.3s;
    }

    .nav-content:hover
    {
        color: #758edf;
    }

    .nav-content.active::after
    {
        width: 100%;
        height: 3px;
        content: '';
        background: #ffffff;
        transition: 0.3s;
    }

    .nav-content.active:hover::after
    {
        background: #758edf;
    }


    @media screen and (min-width: 768px) {
        .p-menubar h2 {
            margin-left: 30px;
        }
    }
    @media screen and (max-width: 960px) {
        .nav-content {
            margin-left: 0;
            text-align: start;
            padding: 0.5rem;
            border-bottom: 1px solid white;
        }
    }
</style>
<style>
    @media screen and (max-width: 960px) {
        .p-menubar .p-menubar-root-list
        {
            background: black !important;
        }
        .p-menubar .p-menubar-button
        {
            width: 3rem !important;
            height: 3rem !important;
            background: none;
            margin-left: auto;
        }
        .p-menubar .p-menubar-button:hover {
            background: none !important;
        }
        .p-menubar .p-menubar-button:focus {
            box-shadow: none !important;
        }
        .p-menubar .pi {
            font-size: 2rem;
            color: #ffffff;
        }
        .p-menubar .p-menubar-end {
            margin-left: 0;
        }
        .p-menubar.p-menubar-mobile-active .p-menubar-root-list {}
    }
</style>